<?php
/**
 * Created by PhpStorm.
 * User: limingze
 * Date: 2016/1/5
 * Time: 11:21
 */

require '/home/wwwroot/CatPHP/catphp/catphp.php';
define('APP_PATH', dirname(__FILE__) . '/../');
ini_set('default_socket_timeout', -1);
//框架集成的log方法
$logger = new Logging('/var/log/wifi_server/websocket.log');

$redis = new Redis();
$redis->connect('127.0.0.1', 6379);
$redis->auth('MhxzKhl');
$redis->select(2);

$server = new swoole_websocket_server("0.0.0.0", 8888);
$server->set(array(
    'worker_num' => 4,    //worker process num
    'backlog' => 128,   //listen backlog
    'max_request' => 50,
    'dispatch_mode'=>1,
));

$server->on('Open', function ($server, $req) {
    global $logger;
    $logger->debug("Host: {$req->header['host']} , Origin: {$req->header['origin']} , Fd: {$req->fd} ",'Open');
});

$globalServer = null;
$reqfd = null;

$server->on('Message', function ($serv, $frame) {
    global $server;
    $server->push($frame->fd,$frame->data);

    global $globalServer;
    $globalServer = $server;

    global $reqfd;
    $reqfd = $frame->fd;

    global $redis;

    //web页面注册registerid
    if(stripos($frame->data,'merchantId_') !== false){

        $fd = $redis->get($frame->data);
        if($fd != null){
            $fd = json_decode($fd,true);
        }

        $fd[$reqfd] = $reqfd;
        $fd = json_encode($fd);
        $redis->set($frame->data,$fd);
    }

    //服务端请求更新数据，这里是websocket方式
    if(stripos($frame->data,'refresh_') !== false){

        $merchantId = explode('_',$frame->data)[1];
        $fd = $redis->get("merchantId_".$merchantId);
        if($fd != null){
            $fd = json_decode($fd,true);
        }

        $err = 0;
        foreach($fd as $f => $d){
            $res = @$server->push($f, "refresh");
            if($res === false){
                unset($fd[$f]);
                $err++;
            }
        }

        if($err){
            $fd = json_encode($fd);
            $redis->set("merchantId_".$merchantId,$fd);
        }
    }
});

$server->on('Close', function ($server, $fd) {
    echo "connection close: " . $fd;
});

//服务端请求更新数据，这里是http方式
$server->on('Request', function ($req, $respone) {

    if(isset($req->get['merchantId'])){
        global $server;
        global $redis;

        $merchantId = $req->get['merchantId'];
        $fd = $redis->get("merchantId_".$merchantId);
        if($fd != null){
            $fd = json_decode($fd,true);
        }

        $err = 0;
        if(is_array($fd)){
            foreach($fd as $f){
                $res = @$server->push($f, "refresh");
                if($res === false){
                    unset($fd[$f]);
                    $err++;
                }
            }

            if($err){
                $fd = json_encode($fd);
                $redis->set("merchantId_".$merchantId,$fd);
            }
        }
    }

    $respone->end("success");
});

$server->start();